/* Copyright (c) Stichting Mathematisch Centrum, Amsterdam, 1991. */

#include "b.h"
#include "b0lan.h"
#include "bmem.h"
#include "bobj.h"
#include "i3sou.h"
#include "i4bio.h"

/* list how-to's and locations on the file 'ofp' */

Visible Procedure abcpack(ofp)
     FILE *ofp;
{
	intlet k, len;
	char *locname, *getlocname();
	char *locval, *getlocval();
	char *line;
	int linelen;
	
	abclist(ofp); /* list how-to's */

	len= length(b_perm);
	for (k= 0; k<len && !Interrupted(); ++k) {
		if ((locname= getlocname(*key(b_perm, k))) == (char *)NULL) {
			continue;
		}
		if ((locval= getlocval(*assoc(b_perm, k))) == (char *)NULL) {
			freestr(locname);
			continue;
		}
		linelen= strlen(K_PUT) + 1 + strlen(locval) + 1 +
		  strlen(K_IN_put) + 1 + strlen(locname);
		line= (char *) getmem((unsigned) (linelen+1));
		sprintf(line, "%s %s %s %s\n", K_PUT, locval, K_IN_put, locname);
		putstr(ofp, line);
		fflush(ofp);
		freestr(line);
		freestr(locval);
		freestr(locname);
	}
}

Hidden char *getlocname(pname)
     value pname;
{
	value name;
	char *locname;

	if (!Is_text(pname) || Permtype(pname) != Tar) return (char *)NULL;
	name= Permname(pname);
	locname= sstrval(name);
	release(name);
	return locname;
}

Hidden char *getlocval(fname)
     value fname;
{
	FILE *fp;
	char *buffer, *pbuf;
	int c;

	if (!Is_text(fname) || !targetfile(fname))
		return (char *)NULL;
	fp= fopen(strval(fname), "r");
	if (fp == (FILE *)NULL)
		return (char *)NULL;
	buffer= pbuf= (char *) getmem((unsigned)(f_size(fp)+2)*sizeof(char));
	while ((c= getc(fp)) != EOF) {
		if (c != '\n') *pbuf++= c;
	}
	*pbuf= '\0';
	fclose(fp);
	if (pbuf == buffer) { /* no value */
		freestr(buffer);
		return (char *)NULL;
	}
	return buffer;
}
